﻿/* 
 * ffmpeg liefert die Bitraten in kbit/s
 * DVD5 hat 4 700 000 000 Byte = 37600000000 Bits
 * = 4589843,75 KB [1024 Byte/KB]
 * DVD9 hat 8 540 000 000 Byte = 68320000000 Bits
 * = 8339843,75 KB [1024 Byte/KB]
 * damit muss man die Audiobitrate noch durch 8 teilen
 * Videobitrate [kbits] = 8 * (Disksize [KB] - (Duration [s] * Audiobitrate [kbit/s]/8)/Duration [s]
  */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;


namespace MPEG2DVD_Converter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        string GlobalerName = "V:\\Sport\\Football\\2010\\ViertelfinaleStuttgartScorpions\\00001977-001.mpg";
        int laenge = 0;
        int vbitrate = 0;
        int abitrate = 0;


        int Disksize = 4589843; //DVD5 
        string exportpath = "D:\\convert\\";
        //string MediaBasePath = "//172.22.1.151\\Mediabase\\";
        string MediaBasePath = "M:\\";

        private void GetStreamInfo(string Dateiname, ref int laenge, ref int vbitrate, ref int abitrate)
        {
            ProcessStartInfo info = new ProcessStartInfo("ffmpeg", "-i "+Dateiname);
            info.UseShellExecute = false;
            info.RedirectStandardError = true;
            info.CreateNoWindow = true;

            Process proc = Process.Start(info);
            proc.WaitForExit();

            string stdError = proc.StandardError.ReadToEnd();

            proc.Close();

            DebugBox.AppendText(stdError);
            int d = stdError.IndexOf("Duration");
            DurationTextBox.Text = stdError.Substring(d + 10, 10);
            int v = stdError.IndexOf("Video");
            int a = stdError.IndexOf("Audio");
            int ende = stdError.IndexOf("At least one output");
            DebugBox.AppendText(Convert.ToString(v)+Environment.NewLine);
            DebugBox.AppendText(Convert.ToString(a) + Environment.NewLine);
            DebugBox.AppendText(Convert.ToString(ende) + Environment.NewLine);
            DebugBox.AppendText(Convert.ToString(a + 7) + Environment.NewLine);
            DebugBox.AppendText(Convert.ToString(ende - a - 9) + Environment.NewLine);
            DebugBox.AppendText(Convert.ToString(v + 7) + Environment.NewLine);
            DebugBox.AppendText(Convert.ToString(a - 2 - v + 7) + Environment.NewLine);

            try
            {
                string Audiostring = stdError.Substring(a + 7, ende - a - 9);
                VideoInfoTextBox.Text = stdError.Substring(v + 7, a - 2 - v + 7);
                AudioInfoTextbox.Text = stdError.Substring(a + 7, ende - a - 9);

                MPEG2Name.Text = Dateiname;
                string Laufzeit = stdError.Substring(d + 10, 10);
                DurationTextBox.Text = Laufzeit + " bzw. ";

                int stunden = Convert.ToInt32(Laufzeit.Substring(0, 2));
                DebugBox.AppendText("Stunden: " + Laufzeit.Substring(0, 2) + Environment.NewLine);
                int minuten = Convert.ToInt32(Laufzeit.Substring(3, 2));
                DebugBox.AppendText("Minuten: " + Laufzeit.Substring(3, 2) + Environment.NewLine);
                int sekunden = Convert.ToInt32(Laufzeit.Substring(6, 2));
                DebugBox.AppendText("Sekunden: " + Laufzeit.Substring(6, 2) + Environment.NewLine);

                int pos1 = Audiostring.LastIndexOf(",") + 2;
                int pos2 = Audiostring.LastIndexOf("kb/s") - 1;
                abitrate = Convert.ToInt32(Audiostring.Substring(pos1, pos2 - pos1));
                DebugBox.AppendText("Audiobitrate: " + Convert.ToString(abitrate ) + Environment.NewLine);
                minuten += stunden * 60;
                sekunden += minuten * 60;
                laenge = sekunden;
                vbitrate = ((Disksize - (sekunden * abitrate / 8)) * 8) / sekunden;
                // bei kürzeren Filmen wird die Video-Bitrate auf das Maximun einer DVD begrenzt.
                if (vbitrate > 9570) vbitrate = 9570;

                DurationTextBox.AppendText(Convert.ToString(sekunden));
                DurationTextBox.AppendText(" Sekunden");
            }
            catch(Exception e)
            {
                using (StreamWriter writer = new StreamWriter(exportpath + "\\log.txt", true))
                {
                    writer.WriteLine(e.StackTrace);
                }
            }

        }

        private void StartProcess(string ProcName, string Arguments)
        {
            try
            {
                ProcessStartInfo psi = new ProcessStartInfo(ProcName, Arguments);
                psi.RedirectStandardError = true;
                psi.RedirectStandardOutput = false;
                psi.UseShellExecute = false;
                psi.CreateNoWindow = true;
                Process p = new Process();

                //p.OutputDataReceived +=
                p.ErrorDataReceived +=
                    new DataReceivedEventHandler(p_OutputDataReceived);
                p.StartInfo = psi;
                p.Start();
                p.BeginErrorReadLine();

                p.WaitForExit();
                //p.ErrorDataReceived -=
                  //  new DataReceivedEventHandler(p_OutputDataReceived);
                p.Close();
                p.Dispose();
            }
            catch (NullReferenceException ne)
            {
                using (StreamWriter writer = new StreamWriter(exportpath + "\\log.txt", true))
                {
                    writer.WriteLine(ne.StackTrace);
                }
            }
        }

        void p_OutputDataReceived(object sender, DataReceivedEventArgs e)
        {
            //Debug.WriteLine(e.Data);

            try
            {
                DebugBox.AppendText(e.Data);
            }
            catch (NullReferenceException ne)
            {
                using (StreamWriter writer = new StreamWriter(exportpath + "\\log.txt", true))
                {
                    writer.WriteLine(ne.StackTrace);
                }
            }
            using (StreamWriter writer = new StreamWriter(exportpath + "\\log.txt", true))
            {
                writer.WriteLine(e.Data);
            }

        }

        private void ConvertButton_Click(object sender, EventArgs e)
        {
            using (StreamWriter writer = new StreamWriter(exportpath + "\\log.txt", false))
            {
                writer.WriteLine("Umwandlung gestartet");
                writer.WriteLine("installiertes .NET-Framework: {0}", System.Environment.Version.ToString());
            }
            string parameter = "-i " + "\"" + GlobalerName + 
                "\"" + " -target dvd -y -b " + Convert.ToString(vbitrate)
                + "k " + exportpath + "tobeconverted.mpg";
            DebugBox.Text=parameter;

            string dateiname = exportpath + "tobeconverted.mpg";

            // Mpeg in DVD-kompatible Größe schrumpfen
            StartProcess("ffmpeg", parameter);

            // DVD-Menu etc. erzeugen
            // tbd

            // DVD-Struktur erzeugen
            try
            {
                StartProcess("dvdauthor", "-v 4:3,720xfull -t -f " + exportpath + "tobeconverted.mpg  -o " + exportpath + "temp");
            }
            catch (NullReferenceException ne)
            {
                using (StreamWriter writer = new StreamWriter(exportpath + "\\log.txt", true))
                {
                    writer.WriteLine(ne.StackTrace);
                }
            }
            // DVD-Table of Contents erzeugen
            StartProcess("dvdauthor",  "-T -o "+ exportpath + "temp");
            // ISO-Image erzeugen
            // tbd
            // PTPublischer-Projekt erzeugen
            // tbd

        }
        
        private void GetFilenameButton_Click(object sender, EventArgs e)
        {
            if (openMPEG2FileDialog.ShowDialog() == DialogResult.OK)
            {
                string Dateiname = "";

                GlobalerName = openMPEG2FileDialog.FileName;
                MPEG2Name.Text = GlobalerName;
                Dateiname = "\"" + GlobalerName + "\"";
                DebugBox.AppendText(Dateiname);

                GetStreamInfo(Dateiname, ref laenge, ref vbitrate, ref abitrate);
                
                DebugBox.AppendText("Videobitrate: ");
                DebugBox.AppendText(Convert.ToString(vbitrate));
                DebugBox.AppendText("kbit/s, Audiobitrate: ");
                DebugBox.AppendText(Convert.ToString(abitrate));
                DebugBox.AppendText("kbit/s");

                //Textfelder sollten Inhalte vorweisen
                //ConvertButton.Enabled = true;
            }
        }


        private void Verantworter_TextChanged(object sender, EventArgs e)
        {
            ConvertButton.Enabled = true;
        }

        private void DBEgetButton_Click(object sender, EventArgs e)
        {
            if (openDBEFileDialog.ShowDialog() == DialogResult.OK)
            {
                // DBE-Datei parsen
                StreamReader Datei = new StreamReader(openDBEFileDialog.FileName);
                string s = Datei.ReadToEnd();
                Datei.Close();
                int posTitle = s.IndexOf("[TITLE]");
                int posSubtitle = s.IndexOf("[SUBTITLE]");
                int posSeries = s.IndexOf("[SERIES]");
                int posAuthor = s.IndexOf("[AUTHOR]");
                int posAuthorplace = s.IndexOf("[AUTHORPLACE]");
                int posProducer = s.IndexOf("[PRODUCER]");
                int posRecDate = s.IndexOf("[RECORDDATE]");
                int posRecPlace = s.IndexOf("[RECORDPLACE]");
                int posDescription = s.IndexOf("[DESCRIPTION]");
                int posFile = s.IndexOf("[FILE]");

                int LengthTitle = posSubtitle - posTitle - 7;
                int LengthSubTitle = posSeries - posSubtitle - 10;
                int LengthAuthor = posAuthorplace - posAuthor - 8;
                int LengthAuthorplace = posProducer - posAuthorplace - 13;
                int LengthRecDate = posRecDate - posRecPlace - 12;
                int LengthRecPlace = posRecPlace - posDescription - 13;
                int LengthFile = s.Length - posFile - 8;

                if (LengthTitle>0) Title.Text = s.Substring(posTitle + 7, LengthTitle);
                if (LengthSubTitle>0) Subtitle.Text = s.Substring(posSubtitle + 10, LengthSubTitle);
                if (LengthAuthor > 0)
                {
                    Verantworter.Text = s.Substring(posAuthor + 8, LengthAuthor);
                    if (LengthAuthorplace > 0)
                    {
                        Verantworter.AppendText(", ");
                        Verantworter.AppendText(s.Substring(posAuthorplace + 13, LengthAuthorplace));
                    }
                }
                if (LengthRecDate>0)RecDate.Text = s.Substring(posRecDate+12, LengthRecDate);
                if (LengthFile > 0)
                {
                    MPEG2Name.Text = s.Substring(posFile + 6, LengthFile);

                    // Datei finden

    
                    DirectoryInfo dir = new DirectoryInfo(@"M:\");          
                    string[] directories = Directory.GetDirectories(@"M:\");
                    FileInfo[] files = dir.GetFiles("*.mpg");

                    string[]lines = new string[files.Length];

                    foreach (FileInfo file in files)
                    {
                    DebugBox.AppendText(file.Name + Environment.NewLine);
                    }
            



                    /*                string Dateiname = "";

                                    GlobalerName
                                    MPEG2Name.Text = GlobalerName;
                                    Dateiname = "\"" + GlobalerName + "\"";
                                    DebugBox.AppendText(Dateiname);

                                    GetStreamInfo(Dateiname, ref laenge, ref vbitrate, ref abitrate);
                
                                    DebugBox.AppendText("Videobitrate: ");
                                    DebugBox.AppendText(Convert.ToString(vbitrate));
                                    DebugBox.AppendText("kbit/s, Audiobitrate: ");
                                    DebugBox.AppendText(Convert.ToString(abitrate));
                                    DebugBox.AppendText("kbit/s");
                  
                     */
                }
            }
        }
    }

}
